composer:
    stage: install
    image: docker.io/laylatichy/ci:build-composer-php81
    artifacts:
        paths:
            - vendor/
        expire_in: 1h
    script:
        - composer install
    retry: 2
    only:
        - dev
        - merge_requests
    except:
        variables:
            - $CI_COMMIT_REF_NAME =~ /^version/

npm:
    stage: install
    image: docker.io/laylatichy/ci:build-node
    artifacts:
        paths:
            - node_modules/
        expire_in: 1h
    script:
        - npm i
    retry: 2
    only:
        - dev
        - merge_requests
    except:
        variables:
            - $CI_COMMIT_REF_NAME =~ /^version/

phpcsfixer:
    stage: lint
    image: docker.io/laylatichy/ci:build-composer-php81
    needs:
        -   job:       composer
            artifacts: true
    script:
        - ./vendor/bin/php-cs-fixer fix --config=.php-cs-fixer.dist.php --stop-on-violation --using-cache=no --verbose --show-progress=dots
    retry: 2
    only:
        - dev
        - merge_requests
    except:
        variables:
            - $CI_COMMIT_REF_NAME =~ /^version/

zx:
    stage: tools
    image: docker.io/laylatichy/ci:build-node
    needs:
        -   job:       npm
            artifacts: true
    before_script:
        - npm i -g zx
    script:
        - zx .ci/scripts/zx_test.mjs
    retry: 2
    only:
        - dev
        - merge_requests
    except:
        variables:
            - $CI_COMMIT_REF_NAME =~ /^version/

phpunit:
    stage: test
    image: docker.io/laylatichy/ci:test-phpunit-php81
    needs:
        -   job:       composer
            artifacts: true
    artifacts:
        paths:
            - _coverage/php/
        expire_in: 1h
    script:
        - composer test
    retry: 2
    only:
        - dev
        - merge_requests
    except:
        variables:
            - $CI_COMMIT_REF_NAME =~ /^version/

phpstan:
    stage: code-analysis
    image: docker.io/laylatichy/ci:build-composer-php81
    needs:
        -   job:       composer
            artifacts: true
    script:
        - vendor/bin/phpstan analyse
    retry: 2
    only:
        - dev
        - merge_requests
    except:
        variables:
            - $CI_COMMIT_REF_NAME =~ /^version/
